diff -urN punbb-1.3.2/lang/English/admin_index.php punbb-1.3.3/lang/English/admin_index.php
--- punbb-1.3.2/lang/English/admin_index.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.3/lang/English/admin_index.php	2009-04-17 12:51:23.000000000 +0000
@@ -1,12 +1,14 @@
 <?php
 
+// Language definitions used in the index page of the admin panel
 $lang_admin_index = array(
 
 'Information head'				=>	'Welcome to PunBB administration control panel',
 'Alerts'						=>	'Administrator Alerts',
 'Check for updates enabled'		=>	'This board is setup to automatically check for updates and hotfixes against the punbb.informer.com updates service.',
 'Check for updates manual'		=>	'Check for updates',	// Link text
-'PunBB version'				=>	'PunBB version',
+'Copyright message'				=>	'&copy; 2008-2009 <a href="http://punbb.informer.com/">PunBB</a>, partially based on code &copy; 2008-2009 <a href="http://fluxbb.org/">FluxBB</a>',
+'PunBB version'					=>	'PunBB version',
 'Not available'					=>	'Not available',
 'Not applicable'				=>	'N/A',
 'Server load'					=>	'Server load',
diff -urN punbb-1.3.2/lang/English/admin_reindex.php punbb-1.3.3/lang/English/admin_reindex.php
--- punbb-1.3.2/lang/English/admin_reindex.php	2008-11-09 17:45:53.000000000 +0000
+++ punbb-1.3.3/lang/English/admin_reindex.php	2009-04-02 13:49:40.000000000 +0000
@@ -10,7 +10,7 @@
 'Empty index warning'		=>	'<strong>WARNING!</strong> If you want to resume an aborted rebuild, do not select "empty index".',
 'Posts per cycle'			=>	'Posts per cycle',
 'Posts per cycle info'		=>	'The number of posts to process per pageview. E.g. if you were to enter 100, one hundred posts would be processed and then the page would refresh. This is to prevent the script from timing out during the rebuild process.',
-'Starting post'				=>	'Starting Post ID',
+'Starting post'				=>	'Starting post ID',
 'Starting post info'		=>	'The post ID to start rebuilding at. The default value is the first available ID in the database. Normally you would not want to change this.',
 'Empty index'				=>	'Empty index',
 'Empty index info'			=>	'Empty search index before rebuilding (see below).',
diff -urN punbb-1.3.2/lang/English/admin_settings.php punbb-1.3.3/lang/English/admin_settings.php
--- punbb-1.3.2/lang/English/admin_settings.php	2008-11-26 13:31:37.000000000 +0000
+++ punbb-1.3.3/lang/English/admin_settings.php	2009-03-19 13:05:44.000000000 +0000
@@ -166,10 +166,10 @@
 'Registration rules'			=>	'Forum rules (enable and compose forum rules)',
 'Registration rules info'		=>	'You may require new users to agree to a set of rules when registering. The rules will always be available through a link in the navigation table at the top of every page. You may enable the use of rules and then compose your rules below.',
 'Registration rules legend'		=>	'Forum rules',
-'Require rules'					=>	'Require agreement',
+'Require rules'					=>	'Use rules',
 'Require rules label'			=>	'Users must agree to forum rules before registering.',
 'Compose rules label'			=>	'Compose rules',
-'Compose rules help'			=>	'You may use HTML as text is not parsed. Leaving empty disables the use of rules.',
+'Compose rules help'			=>	'You may use HTML as text is not parsed.',
 'Rules default'					=>	'Enter your rules here.',
 
 // Email section
diff -urN punbb-1.3.2/lang/English/common.php punbb-1.3.3/lang/English/common.php
--- punbb-1.3.2/lang/English/common.php	2008-12-08 11:53:13.000000000 +0000
+++ punbb-1.3.3/lang/English/common.php	2009-04-17 12:23:47.000000000 +0000
@@ -8,8 +8,8 @@
 'lang_identifier'			=>	'en',
 
 // Number formatting
-'lang_decimal_point'	=>	'.',
-'lang_thousands_sep'	=>	',',
+'lang_decimal_point'		=>	'.',
+'lang_thousands_sep'		=>	',',
 
 // Notices
 'Bad request'				=>	'Bad request. The link you followed is incorrect or outdated.',
@@ -85,7 +85,7 @@
 'Item info single'			=>	'%s [ %s ]',
 'Item info plural'			=>	'%s [ %s to %s of %s ]', // e.g. Topics [ 10 to 20 of 30 ]
 'Info separator'			=>	' ', // e.g. 1 Page | 10 Topics
-'Powered by'				=>	'Powered by <strong>%s</strong>',
+'Powered by'				=>	'Powered by <strong>%s</strong>, supported by <strong>%s</strong>.',
 'Maintenance'				=>	'Maintenance',
 
 // CSRF confirmation form
@@ -146,21 +146,22 @@
 'Jump to'					=>	'Jump to forum:',
 
 // For extern.php RSS feed
-'ATOM Feed'					=>	'Atom',
-'RSS Feed'					=>	'RSS',
 'RSS description'			=>	'The most recent topics at %s.',
 'RSS description topic'		=>	'The most recent posts in %s.',
 'RSS reply'					=>	'Re: ',	// The topic subject will be appended to this string (to signify a reply)
 
 // Accessibility
-'Skip to content'					=>	'Skip to forum content',
+'Skip to content'			=>	'Skip to forum content',
 
 // Debug information
-'Querytime'						=>	'Generated in %1$s seconds, %2$s queries executed',
-'Debug table'						=>	'Debug information',
-'Debug summary'						=>	'Database query performance information',
-'Query times'						=>	'Time (s)',
-'Query'							=>	'Query',
-'Total query time'					=>	'Total query time',
+'Querytime'					=>	'Generated in %1$s seconds, %2$s queries executed',
+'Debug table'				=>	'Debug information',
+'Debug summary'				=>	'Database query performance information',
+'Query times'				=>	'Time (s)',
+'Query'						=>	'Query',
+'Total query time'			=>	'Total query time',
+
+// For official extensions
+'Official extensions inst'	=>	'<span id="extensions-used" title="%1$s">Official extensions: %2$s installed.</span>',
 
 );
diff -urN punbb-1.3.2/lang/English/forum.php punbb-1.3.3/lang/English/forum.php
--- punbb-1.3.2/lang/English/forum.php	2008-11-21 15:42:22.000000000 +0000
+++ punbb-1.3.3/lang/English/forum.php	2009-04-03 10:13:23.000000000 +0000
@@ -24,7 +24,7 @@
 'No lastpost info'			=>	'No last post information',
 'by poster'					=>	'by %s',
 'Item status'				=>	'%s:',
-'Topic starter'				=>	'by %s',
+'Topic starter'				=>	'by <cite>%s</cite>',
 'New posts'					=>	'New posts',
 'Topic navigation'			=>	'( %s )',
 'Location'					=>	'Found in forum: %s',
@@ -43,7 +43,7 @@
 'Forum options'				=>	'Forum options',
 'Moderate forum'			=>	'Moderate forum',
 'Mark forum read'			=>	'Mark forum as read',
-'RSS forum feed'			=>	'RSS Forum Feed',
+'RSS forum feed'			=>	'RSS forum feed',
 'New posts info'			=>	'Go to the first new post since your last visit.'
 
 );
diff -urN punbb-1.3.2/lang/English/help.php punbb-1.3.3/lang/English/help.php
--- punbb-1.3.2/lang/English/help.php	2008-10-25 15:27:40.000000000 +0000
+++ punbb-1.3.3/lang/English/help.php	2009-03-18 14:30:52.000000000 +0000
@@ -36,8 +36,8 @@
 'List text 2'			=>	'Example list item 2.',
 'List text 3'			=>	'Example list item 3.',
 'produces list'			=>	'produces a bulleted list.',
-'produces decimal list'	=>	'produces numbered list.',
-'produces alpha list'	=>	'produces alphabetically labelled list.',
+'produces decimal list'	=>	'produces a numbered list.',
+'produces alpha list'	=>	'produces an alphabetically labelled list.',
 'Bold, underlined text'	=>	'Bold, underlined text',
 'Smilies info'			=>	'If you like (and if it is enabled), the forum can convert a selection of smilies to image representations of those smilies. This forum recognizes the smilies listed below and replaces them with images.'
 
diff -urN punbb-1.3.2/lang/English/index.php punbb-1.3.3/lang/English/index.php
--- punbb-1.3.2/lang/English/index.php	2008-10-25 15:27:40.000000000 +0000
+++ punbb-1.3.3/lang/English/index.php	2009-01-22 10:11:19.000000000 +0000
@@ -42,6 +42,7 @@
 'New posts title'			=>	'This forum contain posts made since your last visit.',
 'Board options'				=>	'Board options',
 'RSS active feed'			=>	'RSS active topics feed',
-'Mark all as read'			=>	'Mark all forums as read'
+'Guests online'				=>	'Guests online',
+'Users online'				=>	'Users online'
 
 );
diff -urN punbb-1.3.2/lang/English/install.php punbb-1.3.3/lang/English/install.php
--- punbb-1.3.2/lang/English/install.php	2008-11-10 18:29:12.000000000 +0000
+++ punbb-1.3.3/lang/English/install.php	2009-04-16 09:17:55.000000000 +0000
@@ -21,7 +21,6 @@
 'Table prefix'				=>	'Table prefix',
 'Database type info'		=>	'PunBB currently supports MySQL, PostgreSQL and SQLite. If your database of choice is missing from the drop-down menu below, it means this PHP environment does not have support for that particular database. More information regarding support for particular versions of each database can be found in the FAQ.',
 'Mysql type info'			=>	'PunBB has detected that your PHP environment supports two different ways of communicating with MySQL. The two options are called "<em>standard</em>" and "<em>improved</em>". If you are uncertain which one to use, start by trying improved and if that fails, try standard.',
-'MySQL InnoDB info'			=>	'PunBB has detected that your MySQL server might support <a href="http://dev.mysql.com/doc/refman/5.0/en/innodb-overview.html">InnoDB</a>. This would be a good choice if you are planning to run a large forum. If you are uncertain, it is recommended to not use InnoDB.',
 'Database server info'		=>	'Enter the address of the database server (example: <em>localhost</em>, <em>mysql1.example.com</em> or <em>208.77.188.166</em>). You can specify a custom port number if your database doesn\'t run on the default port (example: <em>localhost:3580</em>). For SQLite support, just enter anything or leave it at \'localhost\'.',
 'Database name info'		=>	'Enter the name of the database that PunBB will be installed into. The database must exist. For SQLite, this is the relative path to the database file. If the SQLite database file does not exist, PunBB will attempt to create it.',
 'Database username info'	=>	'Enter the username and password used for connecting to the selected database. Ignore for SQLite.',
@@ -78,9 +77,11 @@
 'Invalid table prefix'		=>	'The table prefix \'%s\' contains illegal characters or is too long. The prefix may contain the letters a to z, any numbers and the underscore character. They must however not start with a number. The maximum length is 40 characters. Please choose a different prefix.',
 'SQLite prefix collision'	=>	'The table prefix \'sqlite_\' is reserved for use by the SQLite engine. Please choose a different prefix.',
 'PunBB already installed'	=>	'A table called "%1$susers" is already present in the database "%2$s". This could mean that PunBB is already installed or that another piece of software is installed and is occupying one or more of the table names PunBB requires. If you want to install multiple copies of PunBB in the same database, you must choose a different table prefix.',
-'InnoDB not enabled'		=>	'InnoDB does not seem to be enabled. Please choose a database layer that does not have InnoDB support, or enable InnoDB on your MySQL server.',
+'Invalid language'			=>	'The language pack you have chosen doesn\'t seem to exist or is corrupt. Please recheck and try again.',
 
 // Used in the install
+'Default language'			=>	'Default language',
+'Default language help'		=>	'(If you remove a language pack you must update this setting)',
 'Default announce heading'	=>	'Sample announcement',
 'Default announce message'	=>	'<p>Enter your announcement here.</p>',
 'Default maint message'		=>	"The forums are temporarily down for maintenance. Please try again in a few minutes.<br />\\n<br />\\n/Administrator",
diff -urN punbb-1.3.2/lang/English/profile.php punbb-1.3.3/lang/English/profile.php
--- punbb-1.3.2/lang/English/profile.php	2008-11-26 12:46:21.000000000 +0000
+++ punbb-1.3.3/lang/English/profile.php	2009-04-09 09:06:21.000000000 +0000
@@ -44,13 +44,13 @@
 'Too wide or high'			=>	'The file you tried to upload is wider and/or higher than the maximum allowed %sx%s pixels.',
 'Unknown failure'			=>	'An unknown error occurred. Please try again.',
 'Avatar'					=>	'Avatar',
-'Current avatar'			=>	'Current Avatar',
+'Current avatar'			=>	'Current avatar',
 'No avatar info'			=>	'No avatar is currently uploaded.',
 'Avatar info replace'		=>	'Uploading a new avatar will replace your existing avatar.',
 'Avatar info none'			=>	'To display an avatar you first need to upload one.',
 'Avatar info type'			=>	'The allowed image file types are gif, jpeg and png.',
 'Avatar info size'			=>	'The maximum image size allowed is %sx%s pixels and %s bytes (%s KB).',
-'Delete avatar info'		=>	'Delete avatar to cease displaying any avatar.',
+'Delete avatar info'		=>	'Delete avatar to stop displaying any avatar.',
 'Upload avatar file'		=>	'Upload avatar file',
 'Avatar upload help'		=>	'Select file then update your profile to install.',
 'No upload warn'			=>	'<strong>IMPORTANT! </strong> You must choose a file to upload before updating your profile.',
@@ -183,6 +183,7 @@
 'Change e-mail errors'		=>	'<strong>Warning!</strong> The following errors must be corrected before your e-mail address can be updated:',
 'E-mail key bad'			=>	'The specified e-mail activation key was incorrect or has expired. Please re-request change of e-mail address. If that fails, contact the forum administrator at %s.',
 'E-mail updated'			=>	'Your e-mail address has been updated.',
+'E-mail updated redirect'	=>	'Your e-mail address has been updated. Redirecting…',
 'Wrong password'			=>	'The password you entered was incorrect.',
 'Activate e-mail sent'		=>	'An email has been sent to the specified address with instructions on how to activate the new e-mail address. If it doesn\'t arrive you can contact the forum administrator at %s.',
 'Change your e-mail'		=>	'Change your e-mail address',
diff -urN punbb-1.3.2/lang/English/search.php punbb-1.3.3/lang/English/search.php
--- punbb-1.3.2/lang/English/search.php	2008-10-27 14:45:19.000000000 +0000
+++ punbb-1.3.3/lang/English/search.php	2009-04-16 11:01:09.000000000 +0000
@@ -32,6 +32,10 @@
 'Show as posts'				=>	'As posts',
 'Submit search'				=>	'Submit search',
 'User defined search'		=>	'User defined search',
+'Search in'					=>	'Search in',
+'Message and subject'		=>	'Message text and topic subject',
+'Message only'				=>	'Message text only',
+'Topic only'				=>	'Topic subject only',
 
 // Results
 'Search results'			=>	'Search results',
@@ -47,7 +51,7 @@
 'Posts by user'				=>	'Posts by this user',
 'Perform new search'		=>	'Perform new search',
 'Search options'			=>	'Search options',
-'Location'					=>	'Forum: %s',
+'Posted in'					=>	'Posted in ',
 'No terms'					=>	'You have to enter at least one keyword and/or an author to search for.',
 'No hits'					=>	'Your search returned no hits.',
 'No user posts'				=>	'There are no posts by this user in this forum.',
diff -urN punbb-1.3.2/lang/English/topic.php punbb-1.3.3/lang/English/topic.php
--- punbb-1.3.2/lang/English/topic.php	2008-10-25 15:27:40.000000000 +0000
+++ punbb-1.3.3/lang/English/topic.php	2009-04-03 10:13:23.000000000 +0000
@@ -8,13 +8,14 @@
 'Search replies'		=>	'(%s replies, posted in %s)',
 'Post reply'			=>	'Post reply',
 'Topic closed'			=>	'[ Closed ]',
+'Topic closed info'		=>	'This topic is closed',
 'No permission'			=>	'Sorry! no permission to post a reply',
 'Topic title'			=>	'Topic: %s',
 'Reply title'			=>	'Re: %s',
 'Login to post'			=>	'You must %1$s or %2$s to post a reply',
-'From'					=>	'From:',				// User location
+'From'					=>	'From:', // User location
 'Registered'			=>	'Registered:',
-'Note'					=>	'Note:',				// Admin note
+'Note'					=>	'Note:', // Admin note
 'IP'					=>	'IP:',
 'Posts'					=>	'Posts',
 'Posts info'			=>	'Posts:',
@@ -32,7 +33,7 @@
 'Unsubscribe'			=>	'Unsubscribe',
 'Subscribe'				=>	'Subscribe',
 'Subscribe info'		=>	'Receive email notification of new posts.',
-'RSS topic feed'		=>	'RSS Topic Feed',
+'RSS topic feed'		=>	'RSS topic feed',
 'Quick post'			=>	'Quick reply to this topic',
 'Post'					=>	'Post',
 'Permalink post'		=>	'Permanent link to this post',
@@ -40,10 +41,10 @@
 'Go to profile'			=>	'Go to %s\'s profile',
 'Move'					=>	'Move topic',
 'Topic options'			=>	'Topic options',
-'Open'					=>  'Open topic',
-'Close'					=>  'Close topic',
-'Unstick'				=>  'Unstick topic',
-'Stick'					=>  'Stick topic',
+'Open'					=>	'Open topic',
+'Close'					=>	'Close topic',
+'Unstick'				=>	'Unstick topic',
+'Stick'					=>	'Stick topic',
 'Moderate topic'		=>	'Moderate topic',
 'Required warn'			=>	'You cannot submit or preview an empty message.',
 
diff -urN punbb-1.3.2/lang/English/url_replace.php punbb-1.3.3/lang/English/url_replace.php
--- punbb-1.3.2/lang/English/url_replace.php	2008-10-23 07:49:10.000000000 +0000
+++ punbb-1.3.3/lang/English/url_replace.php	2009-02-03 07:59:05.000000000 +0000
@@ -563,6 +563,13 @@
 'Ь' => '',
 'ь' => '',
 
+'Є' => 'YE',
+'є' => 'YE',
+'Ї' => 'YI',
+'ї' => 'YI',
+'Ґ' => 'KG',
+'ґ' => 'KG',
+
 'ð' => 'd',
 'Ð' => 'D',
 'þ' => 'th',
diff -urN punbb-1.3.2/lang/English/userlist.php punbb-1.3.3/lang/English/userlist.php
--- punbb-1.3.2/lang/English/userlist.php	2008-11-22 19:18:06.000000000 +0000
+++ punbb-1.3.3/lang/English/userlist.php	2009-03-18 14:30:52.000000000 +0000
@@ -23,8 +23,6 @@
 'All users'				=>	'All users',
 'Perform new search'	=>	'Perform new user search',
 'Table summary'			=>	'List of users filtered and sorted according to the criteria (if any) you have chosen.',
-'User list options'		=>	'User list options',
-'Perform new search'	=>	'Perform new user search',
 'Submit user search'	=>	'Submit user criteria',
 'Title'					=>	'Title',
 'Posts'					=>	'Posts'
diff -urN punbb-1.3.2/login.php punbb-1.3.3/login.php
--- punbb-1.3.2/login.php	2008-12-04 16:42:00.000000000 +0000
+++ punbb-1.3.3/login.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Handles logins, logouts, and password reset requests.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
diff -urN punbb-1.3.2/misc.php punbb-1.3.3/misc.php
--- punbb-1.3.2/misc.php	2008-11-26 11:57:07.000000000 +0000
+++ punbb-1.3.3/misc.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Provides various features for forum users (ie: display rules, send emails through the forum, mark a forum as read, etc).
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -106,13 +106,13 @@
 	if ($forum_user['is_guest'])
 		message($lang_common['No permission']);
 
-	$fid = intval($_GET['fid']);
+	$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
 	if ($fid < 1)
 		message($lang_common['Bad request']);
 
 	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
 	// If it's in GET, we need to make sure it's valid.
-	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('markforumread'.intval($_GET['fid']).$forum_user['id'])))
+	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('markforumread'.$fid.$forum_user['id'])))
 		csrf_confirm_form();
 
 	($hook = get_hook('mi_markforumread_selected')) ? eval($hook) : null;
@@ -528,7 +528,7 @@
 
 	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
 	// If it's in GET, we need to make sure it's valid.
-	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('subscribe'.intval($_GET['subscribe']).$forum_user['id'])))
+	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('subscribe'.$topic_id.$forum_user['id'])))
 		csrf_confirm_form();
 
 	($hook = get_hook('mi_subscribe_selected')) ? eval($hook) : null;
@@ -590,7 +590,7 @@
 
 	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
 	// If it's in GET, we need to make sure it's valid.
-	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('unsubscribe'.intval($_GET['unsubscribe']).$forum_user['id'])))
+	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('unsubscribe'.$topic_id.$forum_user['id'])))
 		csrf_confirm_form();
 
 	($hook = get_hook('mi_unsubscribe_selected')) ? eval($hook) : null;
diff -urN punbb-1.3.2/moderate.php punbb-1.3.3/moderate.php
--- punbb-1.3.2/moderate.php	2008-11-22 19:30:49.000000000 +0000
+++ punbb-1.3.3/moderate.php	2009-04-17 12:51:23.000000000 +0000
@@ -2,7 +2,7 @@
 /**
  * Provides various mass-moderation tools to moderators.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -373,7 +373,7 @@
 <?php ($hook = get_hook('mr_confirm_split_posts_pre_subject')) ? eval($hook) : null; ?>
 					<div class="sf-box text required">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_misc['New subject'] ?> <em><?php echo $lang_common['Required'] ?></em></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="new_subject" value="" size="80" maxlength="70" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="new_subject" value="" size="70" maxlength="70" /></span>
 					</div>
 <?php ($hook = get_hook('mr_confirm_split_posts_pre_confirm_checkbox')) ? eval($hook) : null; ?>
 					<div class="sf-box checkbox">
@@ -416,7 +416,7 @@
 
 	// Determine the post offset (based on $_GET['p'])
 	$forum_page['num_pages'] = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
-	$forum_page['page'] = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : intval($_GET['p']);
+	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : intval($_GET['p']);
 	$forum_page['start_from'] = $forum_user['disp_posts'] * ($forum_page['page'] - 1);
 	$forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_posts']), ($cur_topic['num_replies'] + 1));
 	$forum_page['items_info'] = generate_items_info($lang_misc['Posts'], ($forum_page['start_from'] + 1), ($cur_topic['num_replies'] + 1));
@@ -521,7 +521,6 @@
 
 		$forum_page['post_ident'] = array();
 		$forum_page['message'] = array();
-		$forum_page['author_title'] = '';
 		$forum_page['user_ident'] = array();
 		$cur_post['username'] = $cur_post['poster'];
 
@@ -1039,7 +1038,7 @@
 			</div>
 <?php ($hook = get_hook('mr_merge_topics_pre_fieldset')) ? eval($hook) : null; ?>
 			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
-				<legend class="group-legend"><strong><?php echo $lang_misc['Merge topic'] ?></strong></legend>
+				<legend class="group-legend"><strong><?php echo $lang_misc['Merge topics'] ?></strong></legend>
 <?php ($hook = get_hook('mr_merge_topics_pre_redirect_checkbox')) ? eval($hook) : null; ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box checkbox">
@@ -1424,7 +1423,7 @@
 // Determine the topic offset (based on $_GET['p'])
 $forum_page['num_pages'] = ceil($cur_forum['num_topics'] / $forum_user['disp_topics']);
 
-$forum_page['page'] = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
+$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
 $forum_page['start_from'] = $forum_user['disp_topics'] * ($forum_page['page'] - 1);
 $forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_topics']), ($cur_forum['num_topics']));
 $forum_page['items_info'] = generate_items_info($lang_misc['Topics'], ($forum_page['start_from'] + 1), $cur_forum['num_topics']);
@@ -1535,16 +1534,17 @@
 		++$forum_page['item_count'];
 
 		// Start from scratch
-		$forum_page['item_subject'] = $forum_page['item_body'] = $forum_page['item_status'] = $forum_page['item_nav'] = $forum_page['item_title'] = $forum_page['item_subject_status'] = array();
-		$forum_page['item_indicator'] = '';
+		$forum_page['item_subject'] = $forum_page['item_body'] = $forum_page['item_status'] = $forum_page['item_nav'] = $forum_page['item_title'] = $forum_page['item_title_status'] = array();
 
 		if ($forum_config['o_censoring'] == '1')
 			$cur_topic['subject'] = censor_words($cur_topic['subject']);
 
+		$forum_page['item_subject']['starter'] = '<span class="item-starter">'.sprintf($lang_forum['Topic starter'], forum_htmlencode($cur_topic['poster'])).'</span>';
+
 		if ($cur_topic['moved_to'] != null)
 		{
 			$forum_page['item_status']['moved'] = 'moved';
-			$forum_page['item_title']['link'] = '<a href="'.forum_link($forum_url['topic'], array($cur_topic['moved_to'], sef_friendly($cur_topic['subject']))).'"><span>'.$lang_forum['Moved'].'</span> '.forum_htmlencode($cur_topic['subject']).'</a>';
+			$forum_page['item_title']['link'] = '<span class="item-status"><em class="moved">'.sprintf($lang_forum['Item status'], $lang_forum['Moved']).'</em></span> <a href="'.forum_link($forum_url['topic'], array($cur_topic['moved_to'], sef_friendly($cur_topic['subject']))).'">'.forum_htmlencode($cur_topic['subject']).'</a>';
 
 			// Combine everything to produce the Topic heading
 			$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> <strong>'.$forum_page['item_title']['link'].'</strong></h3>';
@@ -1573,8 +1573,33 @@
 				$forum_page['item_status']['posted'] = 'posted';
 			}
 
+			if ($cur_topic['sticky'] == '1')
+			{
+				$forum_page['item_title_status']['sticky'] = '<em class="sticky">'.$lang_forum['Sticky'].'</em>';
+				$forum_page['item_status']['sticky'] = 'sticky';
+			}
+
+			if ($cur_topic['closed'] == '1')
+			{
+				$forum_page['item_title_status']['closed'] = '<em class="closed">'.$lang_forum['Closed'].'</em>';
+				$forum_page['item_status']['closed'] = 'closed';
+			}
+
+			($hook = get_hook('mr_topic_loop_normal_topic_pre_item_title_status_merge')) ? eval($hook) : null;
+
+			if (!empty($forum_page['item_title_status']))
+				$forum_page['item_title']['status'] = '<span class="item-status">'.sprintf($lang_forum['Item status'], implode(', ', $forum_page['item_title_status'])).'</span>';
+
 			$forum_page['item_title']['link'] = '<strong><a href="'.forum_link($forum_url['topic'], array($cur_topic['id'], sef_friendly($cur_topic['subject']))).'">'.forum_htmlencode($cur_topic['subject']).'</a></strong>';
 
+			($hook = get_hook('mr_topic_loop_normal_topic_pre_item_title_merge')) ? eval($hook) : null;
+
+			$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> '.implode(' ', $forum_page['item_title']).'</h3>';
+
+
+			if (empty($forum_page['item_status']))
+				$forum_page['item_status']['normal'] = 'normal';
+
 			$forum_page['item_pages'] = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
 
 			if ($forum_page['item_pages'] > 1)
@@ -1587,35 +1612,13 @@
 				$forum_page['item_status']['new'] = 'new';
 			}
 
-			if (!empty($forum_page['item_nav']))
-				$forum_page['item_title']['nav'] = '<span class="item-nav">'.sprintf($lang_forum['Topic navigation'], implode('&#160;&#160;', $forum_page['item_nav'])).'</span>';
-
-			($hook = get_hook('mr_topic_actions_moved_row_pre_item_title_merge')) ? eval($hook) : null;
+			($hook = get_hook('mr_topic_loop_normal_topic_pre_item_nav_merge')) ? eval($hook) : null;
 
-			$forum_page['item_body']['subject']['title'] = '<h3 class="hn"><span class="item-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span> '.implode(' ', $forum_page['item_title']).'</h3>';
+			if (!empty($forum_page['item_nav']))
+				$forum_page['item_subject']['nav'] = '<span class="item-nav">'.sprintf($lang_forum['Topic navigation'], implode('&#160;&#160;', $forum_page['item_nav'])).'</span>';
 
 			// Assemble the Topic subject
 
-			if ($cur_topic['sticky'] == '1')
-			{
-				$forum_page['item_subject_status']['sticky'] = $lang_forum['Sticky'];
-				$forum_page['item_status']['sticky'] = 'sticky';
-			}
-
-			if ($cur_topic['closed'] == '1')
-			{
-				$forum_page['item_subject_status']['closed'] = $lang_forum['Closed'];
-				$forum_page['item_status']['closed'] = 'closed';
-			}
-
-			($hook = get_hook('mr_topic_actions_moved_row_pre_item_subject_status_merge')) ? eval($hook) : null;
-
-			if (!empty($forum_page['item_subject_status']))
-				$forum_page['item_subject']['status'] = '<span class="item-status">'.sprintf($lang_forum['Item status'], implode(' ', $forum_page['item_subject_status'])).'</span>';
-
-			if (empty($forum_page['item_status']))
-				$forum_page['item_status']['normal'] = 'normal';
-
 			$forum_page['item_body']['info']['replies'] = '<li class="info-replies"><strong>'.forum_number_format($cur_topic['num_replies']).'</strong> <span class="label">'.(($cur_topic['num_replies'] == 1) ? $lang_forum['Reply'] : $lang_forum['Replies']).'</span></li>';
 
 			if ($forum_config['o_topic_views'] == '1')
@@ -1627,8 +1630,9 @@
 			($hook = get_hook('mr_topic_actions_normal_row_pre_output')) ? eval($hook) : null;
 		}
 
-		$forum_page['item_subject']['starter'] = '<span class="item-starter">'.sprintf($lang_forum['Topic starter'], '<cite>'.forum_htmlencode($cur_topic['poster']).'</cite>').'</span>';
-		$forum_page['item_body']['subject']['desc'] = implode(' ', $forum_page['item_subject']);
+		$forum_page['item_body']['subject']['desc'] = '<p>'.implode(' ', $forum_page['item_subject']).'</p>';
+
+		($hook = get_hook('mr_topic_actions_row_pre_item_status_merge')) ? eval($hook) : null;
 
 		$forum_page['item_style'] = (($forum_page['item_count'] % 2 != 0) ? ' odd' : ' even').(($forum_page['item_count'] == 1) ? ' main-first-item' : '').((!empty($forum_page['item_status'])) ? ' '.implode(' ', $forum_page['item_status']) : '');
 
